#define CPPHTTPLIB_OPENSSL_SUPPORT
#include <stdexcept>
#include <mutex>
#include <vector>
#include <optional>
#include "httplib.h"
#include "ui.h"
#include "rei-json/json.h"
#include "slint_string.h"
#include "slint.h"
#include "AppWindow.h"
#include <cstdlib>
#include <filesystem>
#include <fstream>
#include <iostream>
#include <memory>
#include <ostream>
#include <string>
#include <print> 

struct Config {
	std::string timerEndingScript = "";
	int focusDuration = 1500;
	int breakDuration = 300;
	int sessionCount = 4;
};

Config loadJsonConfig(const std::string& configPath) {

	std::ifstream file(configPath);
	Config config{};
	if (!file) {
		std::cerr << "Cant open config file: " << configPath << std::endl;
		return config;
	}
   /* auto jsonConfig = nlohmann::json::parse(file);*/
	/*file.close();*/

	/*if (!jsonConfig.is_object()) {*/
		/*std::cerr << "Config file malformated: " << configPath << std::endl;*/
	/*}*/

	/*if (jsonConfig["timerEndingScript"].is_string()) {*/
		/*config.timerEndingScript = jsonConfig["timerEndingScript"].get<std::string>();*/
	/*}*/
	/*if (jsonConfig["focusDuration"].is_number_integer()) {*/
		/*config.focusDuration = jsonConfig["focusDuration"].get<int>();*/
	/*}*/
	/*if (jsonConfig["breakDuration"].is_number_integer()) {*/
		/*config.breakDuration = jsonConfig["breakDuration"].get<int>();*/
	/*}*/
	/*if (jsonConfig["sessionCount"].is_number_integer()) {*/
		/*config.sessionCount = jsonConfig["sessionCount"].get<int>();*/
	/*}*/
	return config;
}

void saveJsonConfig(const std::string& configPath, const Config& config) {

	/*std::ofstream file(configPath);*/
	/*if (!file) {*/
		/*std::cerr << "Cant open config file: " << configPath << std::endl;*/
		/*return;*/
	/*}*/
	/*nlohmann::json jsonConfig;*/
	/*jsonConfig["timerEndingScript"] = config.timerEndingScript;*/
	/*jsonConfig["focusDuration"] = config.focusDuration;*/
	/*jsonConfig["breakDuration"] = config.breakDuration;*/
	/*jsonConfig["sessionCount"] = config.sessionCount;*/
	/*file << jsonConfig.dump(4);*/
	/*file.close();*/
}

int main(int argc, char **argv)
{
	slint::ComponentHandle<ui::AppWindow> ui = ui::AppWindow::create();
	AppWindow appWindow{ui};
	appWindow.run();

	/*std::vector<std::string> imgsToLoad;*/

	/*std::mutex readLinks;*/
	/*readLinks.lock();*/
	

	/*std::filesystem::create_directory(std::string(getenv("HOME")) + "/.config/focus");*/
	/*const auto configPath = std::string(getenv("HOME")) + "/.config/focus/config.json";*/

	/*slint::ComponentHandle<ui::AppWindow> ui = ui::AppWindow::create();*/

	/*Config config = loadJsonConfig(configPath);*/
	/*ui->global<ui::State>().set_timer_ending_script(slint::SharedString(config.timerEndingScript));*/
	/*ui->global<ui::State>().set_focus_countdown_duration(config.focusDuration);*/
	/*ui->global<ui::State>().set_break_countdown_duration(config.breakDuration);*/
	/*ui->global<ui::State>().set_max_session_count(config.sessionCount);*/

	/*CountdownState countdown(ui);*/

	/*ui->global<ui::State>().on_config_changed([&] {*/
		/*countdown.reset();*/
		/*config.timerEndingScript = ui->global<ui::State>().get_timer_ending_script();*/
		/*config.focusDuration = ui->global<ui::State>().get_focus_countdown_duration();*/
		/*config.breakDuration = ui->global<ui::State>().get_break_countdown_duration();*/
		/*config.sessionCount = ui->global<ui::State>().get_max_session_count();*/
		/*saveJsonConfig(configPath, config);*/
	/*});*/

    return 0;
}
